Subject: Re: [DNA] [Issue 15] [Issue 16] DAD and MLD Interaction

From: Greg Daley <[email-masked]>
Date: Thu, 23 Jun 2005 01:24:35 +1000

Hi Erik, 

----- Original Message -----
[cut]
> > I'd guess it's tied to DNA initiation, rather than the Link-Up
> > explicitly.
> 
> Things wouldn't work safely from a DAD perspective if there is no 
> link-up notification.
> 
> Take an example:
> 1. Host moves and attaches to link B (no link-up notification)
> 2. Host receives a NS for it's link-local address. It responds 
> since it
>    isn't aware that it might have moved to a different link.
> 3. Host receives an unsolicited RA, which has some 'unexpected' things
>    in it (e.g., only unknown prefixes). This triggers DNA; move
>    addresses to optimistic state and send RS.
> 
> The issue is that if the link-local address is a duplicate on the 
> new 
> link, then at #2 the host would mess up things for the existing 
> user of 
> that link-local address on the new link.
> 
> So things can't be very robust without a link-up notification.

Yes, I agree with your point, that link-indications are required.

That's not what I was trying to get at though.

The DAD doesn't need to be done _directly_ due to the link-indication.
It needs to be done because the host thinks it should be doing DNA.

The link-indications pass to the DNA module which then (processing the 
hint)
initializes DNA procedures, including marking of the optimistic flag.

Perhaps it is a minor nit, but I guess it's not a requirement from
the link-indication, rather it is a DNA requirement which also requires
link-indications to function correctly.

Greg

---

From: Greg Daley <[email-masked]>
Date: Thu, 23 Jun 2005 02:10:49 +1000

Hi James, 

----- Original Message -----
From: James Kempf <[email-masked]>
Date: Thursday, June 23, 2005 1:41 am
Subject: Re: [DNA] [Issue 15] [Issue 16] DAD and MLD Interaction

> 
> > Sounds like a reasonable assumption.
> >
> > Should this be tied to the Link-Up indications, or to the DNA 
> reception> and processing of hints?
> >
> > For example, if no link-layer indication is received does the
> > reception of an 'unexpected' RA and subsequent initiation of
> > DNA operations cause Optimistic to be set?
> >
> Well, there's a couple cases to consider.
> 
> Case 1: Multicast RA
> 
> Suppose the host receives a multicast DNA RA, either as a result 
> of failover
> to multicast mode due to RS overload on the router or simply as a 
> multicastbeacon. If the host can conclude that it has not moved to 
> a new IP link, no
> changes in address state are required. If the host can conclude 
> that it has
> moved to a new IP link, the old addresses should be Deprecated, 
> the host
> should form a new link local address, set state to Optimistic, 
> oDAD it, and
> then form new global unicast addresses, etc., just as if it had 
> moved, even
> if it didn't get a link event indicating movement (the link event 
> may have
> failed for some reason). But the host doesn't need to do anything 
> "prior" to
> sending the RS, because it didn't send one.

It's an interesting point.  I'd guess that for non-authoritative
link-change RA reception, you'd want to initiate DNA procedures and
send RS.

If the content of the RA message was enough to go off and configure
addresses (or check router trust with SEND), then the RS would
be unnecessary, as you say.

I'm interested for the hosts document which may need to touch on 
this (while cutting parts out...).

> Case 2: Unsolicted unicast RA
> 
> This case is pretty unlikely and is probably due to an error (or 
> somebodyplaying a trick on the host by sending an RS with the 
> victim's link address
> in the TSLLAO and the victim's link local address as the source 
> address).I'd say in this case the host should be cautious and 
> should issue a unicast
> DNA RA in order to confirm. But I don't think it should make any 
> changes in
> its address state machine in this case, because there is no link event
> indicating a link change. If a link change actually did occur, of 
> course,the addresses need to be reconfigured.

I guess you mean RS.

> How does that sound?

Sounds OK, with the caveat that we wouldn't leave out the Link-hints
(so we don't have confusion on that point). 

Greg